package adminkindboxreqservice

import (
	"context"

	paginationparam "git.gocasts.ir/ebhomengo/niki/param"
	param "git.gocasts.ir/ebhomengo/niki/param/admin/kind_box_req"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
)

// TODO: Pagination, Filters, Sort.
func (s Service) GetAll(ctx context.Context, _ param.KindBoxReqGetAllRequest, paginationreq paginationparam.PaginationRequest) (param.KindBoxReqGetAllResponse, error) {
	const op = "adminkindboxreqservice.GetAll"

	allKindBoxReq, pagination, err := s.repo.GetAllKindBoxReq(ctx, paginationreq)
	if err != nil {
		return param.KindBoxReqGetAllResponse{}, richerror.New(op).WithErr(err).WithKind(richerror.KindUnexpected)
	}

	return param.KindBoxReqGetAllResponse{
		AllKindBoxReq: allKindBoxReq,
		Pagination: paginationparam.PaginationResponse{
			PageSize:   pagination.PageSize,
			PageNumber: pagination.PageNumber,
			Total:      pagination.Total,
		},
	}, nil
}
